from data import STUDENTS, PEOPLE

def R(x):
	return x["has_moodle_account"]

def R2(x):
	return x["has_taken_a_calculus_class"]

def R3(x):
	return not R2(x)

def M(x):
	return x["has_visited_usa"]

def S(x):
	return x["is_student"]

print("Where R(x) is a student who has a mododle account")

# ∀x R(x) 
prop1 = all(map(R, STUDENTS))
print("∀x R(x): ", end="")
print(prop1)

# ∃x R(x)
prop2 = any(map(R, STUDENTS))
print("∃x R(x): ", end="")
print(prop2)

print()
print("Where R(x) is a student that has taken a calculsu course")

# ∀x P(x)
prop3 = all(map(R2, STUDENTS))
print("∀x P(x): ", end="")
print(prop3)

# ∃x ¬P(x)
props4 = any(map(R3, STUDENTS))
print("∃x ¬P(x): ", end="")
print(props4)

print()
print("Where M(x) is somebody who has been to the USA")
print("And U = {all students in CPSC 1820")

# Assume, U = {all students in CPSC 1820}
# ∃x M(x)

props5 = any(map(M, STUDENTS))
print("∃x M(x): ", end="")
print(props5)

# Assume, U = {all people}
# ∃x [S(x) ∧ M(x)]
props6 = any(map(lambda x: M(x) and S(x), PEOPLE))
print("∃x [S(x) ∧ M(x)]: ", end="")
print(props6)

